Index: squid/src/icp_data.c
diff -u /dev/null squid/src/icp_data.c:1.1.2.1
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/icp_data.c	Mon Dec 10 14:22:24 2001
@@ -0,0 +1,414 @@
+/*
+ * $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+ *
+ * DEBUG: section 83  ICP data transmission
+ * AUTHOR: Jon Kay, 1999
+ *
+ * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * --------------------------------------------------------
+ *
+ *  Squid is the result of efforts by numerous individuals from the
+ *  Internet community.  Development is led by Duane Wessels of the
+ *  National Laboratory for Applied Network Research and funded by
+ *  the National Science Foundation.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *  
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *  
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  
+ */
+
+static icpUdpData *UdpQueueHead = NULL;
+static icpUdpData *UdpQueueTail = NULL;
+icpQueue UdpCtlQ;
+static List_Links icpFragQ;
+ICPData_Stats icpdata_stats;
+
+static void icpRecvPush(int fd, struct sockaddr_in *from, icp_common_t *,
+			char *buf, int len);
+static icpFragList *icpFragNew(char *buf, int off, int nextoff, int totlen,
+			       icp_common_t *hdr, int isfirst);
+
+static icpFragList *icpFragFree(icpFragList *fl);
+
+
+#define ICP_PUTLINE "PUT %s HTTP/1.0\r\n"
+
+/* Fragment and encapsulate stuff to be sent */
+void
+icpSendData(int vfd, StoreEntry *entry, struct _pusher *p)
+{
+    int fd = theOutIcpConnection;
+    icpQueue *q = p->q;
+    int len, hdrlen, curlen;
+    struct icp_datab_s *dbhdr;
+    struct _http_reply *reply;
+    struct icp_data_s *dhdr;
+    char *firstline, *lnend;
+    icp_common_t *hdr;
+    char *buf, *tbuf;
+    icpUdpData *pktl;
+    int islast = 0;
+    int lchg, nllen, ollen;
+
+    ++icpdata_stats.nsends;
+    debug(12, 5, "icpDataSend: vfd %d fd %d '%s'\n", vfd, fd, entry->key);
+
+    reply = entry->mem_obj->reply;
+    curlen = entry->mem_obj->e_current_len;
+    if (p->objlen == 0)
+	p->objlen = reply->content_length + reply->hdr_sz;
+    
+    if (p->off < p->objlen)
+	/* Reregister handler */
+	/* excess storeRegisters deregistered in putSendDone() call */
+	storeRegister(entry, vfd, (PIF) icpSendData, p);
+
+    while (p->off < curlen) {
+	/* Allocate 8k page, and put AppendUdp and ICP headers at beginning */
+	buf = get_free_8k_page();
+	hdr = (icp_common_t *) buf;
+	tbuf = (char *) &hdr[1];
+
+	/* Fill in ICP header */
+	hdr->version = ICP_VERSION_CURRENT;
+	hdr->flags = 0;
+	hdr->pad = 0;
+	hdr->shostid = htonl(theOutICPAddr.s_addr);
+
+	/* Is this the last fragment? */
+	/* note: object_len == e_current_len iff storeComplete been called */
+	islast = (p->off + 8000 >= entry->mem_obj->e_current_len
+		  && (entry->object_len == curlen || p->objlen <= curlen));
+
+	if (p->off == 0) {
+	    /* First fragment */
+	    p->reqnum = htonl(storeReqnum(entry, METHOD_PUT));
+	    hdr->opcode = ICP_OP_DATABEG;
+	    dbhdr = (struct icp_datab_s *) tbuf;
+	    tbuf = (char *)  &dbhdr->db_data;
+	    dbhdr->db_ttl = htonl(8); /* XXX*/
+	    dbhdr->db_ts = htonl(entry->lastmod);
+	    hdrlen = sizeof(icp_common_t) + 12;
+	}
+	else {
+	    /* Remaining fragments */
+	    hdr->opcode = islast ? ICP_OP_DATAEND : ICP_OP_DATA;
+	    dhdr = (struct icp_data_s *) tbuf;
+	    tbuf = (char *) &dhdr->d_data;
+	    dhdr->d_offset = htonl(p->off);
+	    hdrlen = sizeof(icp_common_t) + 4;
+	}
+	       
+	storeClientCopy(entry, p->off, 8000, tbuf, &len, vfd);
+
+	if (p->off == 0) {
+	    /* Change the first line into a PUT line from a REPLY line */
+	    firstline = xmalloc(sizeof(ICP_PUTLINE) + strlen(entry->url));
+	    sprintf(firstline, ICP_PUTLINE, entry->url);
+	    lnend = strchr(tbuf, '\n');
+	    if (lnend == NULL) {
+		/* Not enough stuff to send. */
+		safe_free(firstline);
+		safe_free(buf);
+		storeUnregister(entry, vfd);
+		return;
+	    }
+	    while (lnend[1] == '\r' || lnend[1] == '\n')
+		++lnend;
+	    ollen = lnend - tbuf + 1;
+	    nllen = strlen(firstline);
+	    lchg = nllen - ollen;
+	    memmove(tbuf + nllen, tbuf + ollen, len - ollen);
+	    xmemcpy(tbuf, firstline, nllen);
+	    p->objlen += lchg;
+	    len += lchg;
+	    dbhdr->db_size = htonl(p->objlen);
+	}
+	    
+        p->off += len;
+	
+	hdr->length = hdrlen + len;
+	hdr->length = htons(hdr->length);
+	hdr->reqnum = p->reqnum;
+	
+	pktl = (icpUdpData *) xmalloc(sizeof(*pktl));
+	pktl->address = q->dst;
+	pktl->msg = buf;
+	pktl->len = hdrlen + len;
+	pktl->start = current_time;
+	pktl->logcode = LOG_TAG_NONE;
+	pktl->proto = PROTO_NONE;
+	AppendUdp(q, pktl);
+	if (q->maxrate)
+	    icpUdpReply(fd, q);
+	else
+	    commSetSelect(fd, COMM_SELECT_WRITE,
+			  (PF) icpUdpReply, (void *) q, 0);
+
+	if (islast)
+	    putSendDone(p->fd, p);
+    }
+
+    if (p->off >= p->objlen)
+	storeUnregister(entry, vfd);
+}
+
+void
+icpRecvData(int fd, struct sockaddr_in *src, icp_common_t *hdr, char *buf, int len)
+{
+    struct icp_datab_s *dbhdr;
+    struct icp_data_s *dhdr;
+    icpFragList *fl, *fl2, *efl;
+    int off, datalen, objlen;
+    int ismerged;
+    char *nbuf;
+    
+    if (len < sizeof(icp_common_t)) {
+	debug(12, 0, "icpRecvData: packet shorter than headers (%d bytes)\n", len);
+	return;
+    }
+    if (len < hdr->length) {
+	debug(12, 0, "icpRecvData: incomplete packet (%d bytes out of %d bytes)\n",
+	      len, hdr->length);
+	return;
+    }
+	
+    if (hdr->opcode == ICP_OP_DATABEG) {
+	dbhdr = (struct icp_datab_s *) buf;
+	buf = (char *) &dbhdr->db_data;
+	datalen = hdr->length - sizeof(icp_common_t) - 12;
+	off = 0;
+	objlen = ntohl(dbhdr->db_size);
+	if (objlen <= datalen) {
+	    /* One packet long - no defrag needed. */
+	    nbuf = xmalloc(objlen + 1);
+	    xmemcpy(nbuf, buf, objlen);
+	    icpRecvPush(fd, src, hdr, nbuf, objlen);
+	    return;
+	}
+    }
+    else if (hdr->opcode == ICP_OP_DATA || hdr->opcode == ICP_OP_DATAEND) {
+	/* A middle fragment */
+	dhdr = (struct icp_data_s *) buf;
+	buf = (char *) &dhdr->d_data;
+	datalen = hdr->length - sizeof(icp_common_t) - 4;
+	off = ntohl(dhdr->d_offset);
+	objlen = 0;
+    }
+    else {
+	debug(12, 0, "icpRecvData: invalid opcode %d\n", hdr->opcode);
+	return;
+    }
+
+    /* Find first fragment, with entry */
+    debug(12, 5, "icpRecvData: id 0x%x defragging %d-%d\n",
+	   hdr->reqnum, off, off + datalen);
+    ++icpdata_stats.nfrags;
+    efl = NULL;
+    ismerged = 0;
+    if (off == 0) {
+	assert(objlen);
+	fl = icpFragNew(buf, off, off + datalen, objlen, hdr, (int) efl);
+	LIST_FORALL2(&fl->links, icpFragList *, fl2); {
+	    /* Look for more fragments */
+	  loopstart:
+	    if (fl2->hdr.reqnum == hdr->reqnum && fl2->off == fl->nextoff) {
+		/* Consolidate this fragment */
+		
+		if (fl2->off == 0) {
+		    /* this is a dup */
+		    ++icpdata_stats.ndups;
+		    icpFragFree(fl);
+		    return;
+		}
+		
+		/* merge data */
+		if (fl->nextoff < fl2->nextoff)
+		    fl->nextoff = fl2->nextoff;
+		xmemcpy(fl->buf + fl2->off, fl2->buf, fl2->nextoff - fl2->off);
+
+		/* delete old fragment */
+		fl2 = icpFragFree(fl);
+		
+		goto loopstart;
+	    }
+	}
+    }
+    else {
+	LIST_FORALL2(&icpFragQ, icpFragList *, fl) {
+	    if (fl->hdr.reqnum == hdr->reqnum && fl->off == 0) {
+		if (!efl)
+		    efl = fl;
+		if (fl->nextoff == off) {
+		    /* Append to this packet */
+		    fl->nextoff += datalen;
+		    xmemcpy(fl->buf + off, buf, datalen);
+		    ismerged = 1;
+		    if (fl->off == 0 && fl->objlen > 0 && fl->nextoff >= fl->objlen) {
+			/* Assembly complete*/
+			icpRecvPush(fd, src, &fl->hdr, fl->buf, fl->objlen);
+			fl->buf = 0;
+			icpFragFree(fl);
+			return;
+		    }
+		}
+	    }
+	}
+	if (!ismerged)
+	    icpFragNew(buf, off, off + datalen, objlen, hdr, (int) efl);
+    }
+}
+
+static icpFragList *
+icpFragNew(char *buf, int off, int nextoff, int objlen,
+	   icp_common_t *hdr, int isfirst)
+{
+    icpFragList *fl;
+    int len;
+
+    fl = (icpFragList *) xmalloc(sizeof *fl);
+    List_Insert(&fl->links, LIST_ATREAR(&icpFragQ));
+
+    len = (off ? nextoff - off : objlen + 1);
+    fl->buf = xmalloc(len + 1);
+    
+    xmemcpy(fl->buf, buf, nextoff - off);
+    fl->lasttime = squid_curtime;
+    fl->hdr = *hdr;
+    fl->off = off;
+    fl->nextoff = nextoff;
+    fl->objlen = objlen;
+
+    return(fl);
+}
+
+static icpFragList *
+icpFragFree(icpFragList *fl)
+{
+    icpFragList *nfl;
+    
+#if 0
+    printf("icpFragFree: id 0x%x freeing %d-%d obj at 0x%x\n",
+	   fl->hdr.reqnum, fl->off, fl->nextoff, fl->buf);
+#endif
+    nfl = (icpFragList *) List_Next(&fl->links);
+    List_Remove(&fl->links);
+    if (fl->buf)
+	safe_free(fl->buf);
+    safe_free(fl);
+    return(nfl);
+}
+
+static void
+icpFragTimer()
+{
+    icpFragList *fl;
+#if 0 /* JSKDEBUG */
+    int nfrags = 0, mem = 0;
+#endif    
+
+    eventAdd("icpdata fragment timer", (EVH) icpFragTimer, NULL,
+	     Config.icp_frag_tmo);
+    
+    LIST_FORALL2(&icpFragQ, icpFragList *, fl) {
+      loopstart:
+	if ((char *) fl != (char *) &icpFragQ) {
+#if 0 /* JSKDEBUG */
+	    ++nfrags;
+	    mem += fl->objlen + sizeof(*fl);
+#endif    
+	    if (squid_curtime - fl->lasttime >= Config.icp_frag_tmo) {
+		++icpdata_stats.ntmofrags;
+		fl = icpFragFree(fl);
+		goto loopstart;
+	    }
+	}
+    }
+#if 0 /* JSKDEBUG */
+    printf("icpFragTimer: %d frags, for total of %d bytes used\n",
+	   nfrags, mem);
+#endif    
+}
+
+
+static void
+icpRecvPush(int fd, struct sockaddr_in *src, icp_common_t *hdr,char *buf, int len)
+{
+    icpStateData *icpState = xcalloc(sizeof(icpStateData), 1);
+    request_t *request = NULL;
+    int err;
+
+    debug(12, 3, "icpRecvPush on fd %d: Hi!\n", fd);
+    ++icpdata_stats.nrecvs;
+
+    /* Construct icpState */
+    icpState->start = current_time;
+    icpState->inbuf = buf;
+    icpState->inbufsize = 8192;
+    icpState->header = *hdr;
+    icpState->peer = *src;
+    icpState->log_addr = src->sin_addr;
+    icpState->log_addr.s_addr &= Config.Addrs.client_netmask.s_addr;
+    icpState->log_type = LOG_UDP_PUT;
+    icpState->me = *getMyAddr();
+    icpState->me.sin_port = Config.Port.icp;
+    icpState->entry = NULL;
+    icpState->in_offset = len;
+    icpState->fd = comm_virtual_fd();
+    
+    fd_note(fd, inet_ntoa(icpState->log_addr));
+    comm_add_close_handler(icpState->fd, icpStateFree, (void *) icpState);
+    
+    err = parseHttpRequest(icpState);
+    icpState->inbuf[icpState->in_offset] = '\0';    /* Terminate the string */
+    if (err == 1) {
+	if ((request = urlParse(icpState->method, icpState->url)) == NULL) {
+	    debug(12, 0, "icpRecvPush: Invalid URL: %s\n", icpState->url);
+	    return;
+	}
+	safe_free(icpState->log_url);
+	icpState->log_url = xstrdup(urlCanonicalClean(request));
+	request->http_ver = icpState->http_ver;
+	if (!urlCheckRequest(request)) {
+	    debug(12, 0, "icpRecvPush: Invalid request: %s\n");
+	    return;
+	}
+	icpState->request = requestLink(request);
+
+	/* XXX - Uncomment to make acls work with icpdata pushes */
+	/* Currently causes core dump, needs debugging */
+	/* clientAccessCheck(icpState, clientAccessCheckDone);*/
+    }
+    else if (err == 0) {
+	debug(12, 0, "icpRecvPush: got partial request\n");
+	return;
+    }
+    else { /* err == -1 */
+	debug(12, 0, "icpRecvPush: got invalid request\n");
+	return;
+    }
+
+    putRecv(icpState);
+}
+
+void
+icpDataInit()
+{
+    List_Init(&icpFragQ);
+    List_Init(&UdpCtlQ.links);
+    UdpCtlQ.nextsend.tv_sec = UdpCtlQ.nextsend.tv_usec = 0;
+    UdpCtlQ.maxrate = 0;
+    eventAdd("icpdata fragment timer", (EVH) icpFragTimer, NULL,
+	     Config.icp_frag_tmo);
+}
Index: squid/src/icp_v2.c
diff -u squid/src/icp_v2.c:1.6 squid/src/icp_v2.c:1.5.14.3
--- squid/src/icp_v2.c:1.6	Fri Aug  9 14:46:02 2002
+++ squid/src/icp_v2.c	Tue Sep  3 10:41:49 2002
@@ -302,6 +302,14 @@
 	neighborsUdpAck(key, &header, &from);
 	break;
 
+#if USE_ICP_DATA
+    case ICP_OP_DATABEG:
+    case ICP_OP_DATA:
+    case ICP_OP_DATAEND:
+	icpRecvData(fd, &from, &header, buf + sizeof(header), len);
+	break;
+#endif
+
     case ICP_INVALID:
     case ICP_ERR:
 	break;
Index: squid/src/icp_v3.c
diff -u squid/src/icp_v3.c:1.5 squid/src/icp_v3.c:1.4.44.3
--- squid/src/icp_v3.c:1.5	Fri Aug  9 14:46:02 2002
+++ squid/src/icp_v3.c	Tue Sep  3 10:41:49 2002
@@ -143,6 +143,14 @@
 	neighborsUdpAck(key, &header, &from);
 	break;
 
+#if USE_ICP_DATA
+    case ICP_OP_DATABEG:
+    case ICP_OP_DATA:
+    case ICP_OP_DATAEND:
+	icpRecvData(fd, &from, &header, buf + sizeof(header), len);
+	break;
+#endif
+
     case ICP_INVALID:
     case ICP_ERR:
 	break;
Index: squid/src/main.c
diff -u squid/src/main.c:1.36 squid/src/main.c:1.28.2.6
--- squid/src/main.c:1.36	Thu Aug  8 12:41:58 2002
+++ squid/src/main.c	Tue Sep  3 10:41:51 2002
@@ -336,6 +336,7 @@
     externalAclShutdown();
     storeDirCloseSwapLogs();
     errorClean();
+    distInit();
     enter_suid();		/* root to read config file */
     parseConfigFile(ConfigFile);
     setEffectiveUser();
@@ -511,6 +512,12 @@
 #if DELAY_POOLS
 	delayPoolsInit();
 #endif
+#if USE_HINT_CACHE
+	hintCacheInit();
+#endif	
+#if USE_ICP_DATA
+	icpDataInit();
+#endif
 	fwdInit();
     }
 #if USE_WCCP
@@ -626,6 +633,7 @@
 	eventInit();		/* eventInit() is required for config parsing */
 	storeFsInit();		/* required for config parsing */
 	authenticateSchemeInit();	/* required for config parsign */
+	distInit();             /* Needed for fwdall list */
 	parse_err = parseConfigFile(ConfigFile);
 
 	if (opt_parse_cfg_only)
Index: squid/src/mem.c
diff -u squid/src/mem.c:1.20 squid/src/mem.c:1.13.8.1
--- squid/src/mem.c:1.20	Sat Jul 20 18:06:07 2002
+++ squid/src/mem.c	Tue Sep  3 10:41:52 2002
@@ -323,10 +323,6 @@
 memInit(void)
 {
     int i;
-
-    debug(13, 1) ("Memory pools are '%s'; limit: %.2f MB\n",
-	(Config.onoff.mem_pools ? "on" : "off"), toMB(mem_idle_limit));
-
     /* set all pointers to null */
     memset(MemPools, '\0', sizeof(MemPools));
     /*
Index: squid/src/protos.h
diff -u squid/src/protos.h:1.59 squid/src/protos.h:1.41.2.7
--- squid/src/protos.h:1.59	Sat Jul 20 05:33:16 2002
+++ squid/src/protos.h	Tue Sep  3 10:41:54 2002
@@ -180,6 +180,9 @@
 extern void commCloseAllSockets(void);
 extern void checkTimeouts(void);
 extern int commDeferRead(int fd);
+#if USE_ICP_DATA
+extern int comm_virtual_fd(void);
+#endif /* USE_ICP_DATA */
 
 
 /*
@@ -313,6 +316,9 @@
 extern int httpAnonHdrDenied(http_hdr_type hdr_id);
 extern void httpBuildRequestHeader(request_t *, request_t *, StoreEntry *, HttpHeader *, int, http_state_flags);
 extern void httpBuildVersion(http_version_t * version, unsigned int major, unsigned int minor);
+extern HttpStateData *httpStateFromClient(clientHttpRequest *http);
+extern PF httpReadReply;
+extern PF httpStateFree;
 extern const char *httpMakeVaryMark(request_t * request, HttpReply * reply);
 
 /* ETag */
@@ -532,6 +538,12 @@
     int reqnum,
     int pad);
 extern int icpUdpSend(int, const struct sockaddr_in *, icp_common_t *, log_type, int);
+#if USE_ICP_DATA
+void icpSendData(int vfd, StoreEntry *entry, struct _pusher *p);
+void icpRecvData(int fd, struct sockaddr_in *src, icp_common_t *hdr,
+		 char *buf, int len);
+void icpDataInit();
+#endif
 extern PF icpHandleUdp;
 extern PF icpUdpSendQueue;
 extern PF httpAccept;
@@ -1102,7 +1114,8 @@
 
 extern char *url_convert_hex(char *org_url, int allocate);
 extern char *url_escape(const char *url);
-extern protocol_t urlParseProtocol(const char *);
+extern protocol_t urlParseProtocol(const char *, u_short *,
+				   int *);
 extern method_t urlParseMethod(const char *);
 extern void urlInitialize(void);
 extern request_t *urlParse(method_t, char *);
@@ -1288,6 +1301,26 @@
 extern void logfilePrintf(va_alist);
 #endif
 
+/* put.c */
+void putRecv(clientHttpRequest *);
+Pusher *putSend(StoreEntry *, struct sockaddr_in *, PF, void *,
+		int dodist);
+void putSendDone(int fd, void *data);
+void putReplyAndClose(int, StoreEntry *);
+void statPutPrint(StoreEntry * sentry);
+
+/* dist.c */
+extern Updatee *distNewUpdatee(StoreEntry *entry,
+			       struct in_addr host, u_short dport);
+extern void distDelUpdatees(Updatee *u);
+extern void distDelUpdatee(StoreEntry *entry, struct in_addr host, int dport);
+extern void distUpdateeChangeEntry(StoreEntry *entry, Updatee *u);
+extern void distEntryUpdate(StoreEntry *e, request_t *req,
+				     struct sockaddr_in *peer);
+extern char *distifyUrl(char *url);
+extern void distInputDone(StoreEntry *);
+void distInit();
+
 /*
  * Removal Policies
  */
@@ -1312,6 +1345,146 @@
  */
 extern StatCounters *snmpStatGet(int);
 
+
+#if USE_HINT_CACHE
+/* Hint Cache Interface */
+/* open existing cache; return nonzero on error */
+int hintCacheInit();
+void hintCacheCreate();              /* create new cache */
+void hintCacheDestroy();
+void hintCacheInformLocalCopy(StoreEntry *); /* tell hierarchy I have a copy */
+void hintCacheInvalLocalCopy(StoreEntry *); /* say I don't have a copy */
+int hintCacheActive();  /* Ask hint cache if it is operational. */
+struct sockaddr_in *hintCachefindNearest(char *url, struct sockaddr_in *);
+
+void hintCacheNodeKeyInit(NodeKey *k, const struct sockaddr_in *addrP);
+int hintCacheNodeKeyCompare(const NodeKey *k1, const NodeKey *k2);
+struct sockaddr_in hintCacheNodeKeyGetAddr(const NodeKey *k);
+HintCacheKey hintCacheNodeKeyKey(const struct sockaddr_in *addrP);
+
+void hintCacheEntryInit(HintCacheEntry *, URLKey, struct sockaddr_in *,
+			   unsigned int mtime);
+int hintCacheEntryCompare(HintCacheEntry *e1, HintCacheEntry *e2);
+void hintCacheEntryInitNet(HintCacheEntryNet *mungedEntry, HintCacheEntry *entry);
+void hintCacheEntryLocalFormatNet(HintCacheEntryNet *mungedEntry, HintCacheEntry *entry);
+
+int hintCacheUpdateCompare(HintCacheUpdate *u1, HintCacheUpdate *u2);
+void hintCacheUpdateInit(HintCacheUpdate *, int action, HintCacheEntry *, int hopcount);
+
+void hintCacheUpdateInitNet(HintCacheUpdateNet *mungedUpdate, HintCacheUpdate *update);
+void hintCacheUpdateLocalFormatNet(HintCacheUpdateNet *mungedUpdate, HintCacheUpdate *update);
+int hintCacheURLKeyCompare(URLKey *u1, URLKey *u2);
+StoreEntry *hintCacheStoreGet(URLKey urlkey);
+
+
+/* Hint Cache Disk */
+void hintCacheDiskInit(HintCacheDisk *d, char *diskPath);
+void hintCacheDiskClose(HintCacheDisk *d);
+void hintCacheDiskCreateFile(char *hcPath, int size, int associativity);
+void hintCacheDiskInformLocal(HintCacheDisk *d, URLKey key, unsigned mtime);
+void hintCacheDiskInvalLocal(HintCacheDisk *d, URLKey key, unsigned mtime);
+void hintCacheDiskPrefetch(HintCacheDisk *d, HintCacheUpdate *uArray, int nupdates);
+int hintCacheDiskNetInvalRecord(HintCacheDisk *d, HintCacheEntry *target, HintCacheEntry *survivor);
+int hintCacheDiskUpdateIfCloser(HintCacheDisk *d, HintCacheEntry *new);
+int hintCacheDiskFindNearest(HintCacheDisk *d, URLKey key, HintCacheEntry *match);
+void hintCacheDiskDeleteHintCache();
+
+long long unsigned  hintCacheEndian_llNetToMachine(long long unsigned net);
+long long unsigned hintCacheEndian_llMachineToNet(long long unsigned  mach);
+void hintCacheEndian_selfTest(void);
+
+void hintCacheInitNet(HintCacheNet *n);
+int hintCacheNetIsInitialized(void);
+ void hintCacheNetDestroy(HintCacheNet *n);
+void hintCacheNetEnqueue(HintCacheNet *, int action,
+			  HintCacheEntry *, int hopcount);
+int hintCacheNetBytesReady(HintCacheNet *n);
+void hintCacheNetComplete(HintCacheNet *n);
+void hintCacheNetDone(HintCacheNet *n);
+void hintCacheNetSendTo(HintCacheNet *, struct sockaddr_in *);
+void hintCacheNetSendJoin();
+void hintCacheNetDataArrives(char *data, int len, HintCacheNetHeader *hdr,
+				struct sockaddr_in *source);
+void hintCacheNetSetTestMode(HintCacheNet *n);
+int hintCacheNetGetTestCount(HintCacheNet *n);
+
+void hintCachePropLocalAction(StoreEntry *, int action);
+void hintCachePropHandleInvalToChild(HintCacheUpdate *update,
+				      struct sockaddr_in *src, int local);
+void hintCachePropHandleInformToChild(HintCacheUpdate *update,
+				       struct sockaddr_in *src, int local) ;
+void hintCachePropHandleInvalToParent(HintCacheUpdate *update,
+				       struct sockaddr_in *src, int local);
+void hintCachePropHandleInformToParent(HintCacheUpdate *update,
+					struct sockaddr_in *src, int local);
+
+void hintCacheNodelistInit(); /* constructor */
+void hintCacheNodelistDestroy(); /* destructor */
+void hintCacheNodelistSelfTest();
+void hintCacheNodelistLocalJoin(); /* I do a join */
+void hintCacheNodelistLocalLeave(); /* I do a leave */
+int hintCacheNodelistMyStatus(); /* Am I in or out? */
+void hintCacheNodelistNetJoin(struct sockaddr_in *sin, int hops, long long timeNS);
+void hintCacheNodelistNetLeave(struct sockaddr_in *sin, int hops, long long timeNS);
+void hintCacheNodelistIterStart(HintCacheNodeListIter *iter);
+int hintCacheNodelistIterCheck(HintCacheNodeListIter iter);
+void hintCacheNodelistIterNext(HintCacheNodeListIter *iter);
+int hintCacheNodelistIterGetAddr(HintCacheNodeListIter iter,
+				  struct sockaddr_in *ret);
+
+void hintCacheHierUpdateMembershipNeighbor(struct sockaddr_in *neighbor, 
+                                     NeighborAction);
+void hintCacheHierInit();
+void hintCacheHierDestroy();
+int hintCacheHierCompareDistanceFromMe(struct in_addr new, struct in_addr old);
+void hintCacheHierNewNode(struct sockaddr_in *sin, int hops, long long time);
+void hintCacheHierDelNode(struct sockaddr_in *sin, int hops, long long time);
+int hintCacheHierCheckIfParent(URLKey key, struct sockaddr_in *candidate);
+int hintCacheHierCheckIfChild(struct sockaddr_in *candidate);
+void hintCacheHierAddChild(struct sockaddr_in *child);
+void hintCacheHierRemoveChild(struct sockaddr_in *child);
+int hintCacheHierNChildrenQs();
+int hintCacheHierChildQIndex(URLKey *key, int iAmRoot, int *amILeaf);
+int hintCacheHierGetChildAddrs(int qIndex, struct sockaddr_in **retAddr);
+int hintCacheHierNParentQs();
+int hintCacheHierParentQIndex(URLKey *key, int *amIRoot);
+int hintCacheHierGetParentAddr(int index, struct sockaddr_in *retAddr);
+int hintCacheHierSendToParent(struct sockaddr_in *src, HintCacheUpdate *update,
+				 int msgtype);
+int hintCacheHierSendToSiblings(struct sockaddr_in *src, HintCacheUpdate *update,
+				   int msgtype, int siblingtype);
+
+#ifdef USE_DYNAMIC_HIERARCHY
+/* Plaxton Dynamic Hierarchy algorithm */
+void plaxtonInit(int bitsPerLevel);
+void plaxtonDestroy();
+int plaxtonChildQIndex(URLKey *key, int iAmRoot, int *amILeaf);
+int plaxtonNChildrenQsI();
+int plaxtonGetChildAddrs(int qIndex, struct sockaddr_in **retAddrAP);
+int plaxtonNParentQs();
+int plaxtonParentQIndex(URLKey *key, int *amIRoot);
+int plaxtonGetParentAddr(int index, struct sockaddr_in *retAddr);
+/*
+ * Callbacks when nodes added/removed/change distance 
+ */
+void plaxtonAddNode(struct sockaddr_in *newNode);
+void plaxtonRemoveNode(struct sockaddr_in *goneNode);
+void plaxtonChangeDistance(struct sockaddr_in *changeDistNode);
+int plaxtonCheckIfParent(URLKey key, struct sockaddr_in *candidate);
+int plaxtonCheckIfChild(struct sockaddr_in *candidate);
+void plaxtonAddChild(struct sockaddr_in *child);
+void plaxtonRemoveChild(struct sockaddr_in *child);
+int plaxtonMatchBits(HintCacheKey k1, HintCacheKey k2);
+HintCacheKey plaxtonMyNodeKey();
+
+extern int Plaxton_BucketsPerLevel;
+extern HintCacheNet *Plaxton_parentOutgoingA;
+extern HintCacheNet *Plaxton_childrenOutgoingA;
+extern HintCacheNet *Plaxton_neighborsOutgoing;
+#endif /* USE_DYNAMIC_HIERARCHY / Plaxton algorithm */
+
+#endif /* USE_HINT_CACHE */
+
 /* Vary support functions */
 int varyEvaluateMatch(StoreEntry * entry, request_t * req);
 
